$(function(){
    
    $('[data-toggle="tooltip"]').tooltip({
        container : 'body'
    });

    var maxDate = new Date();
    var role = $('#to').attr('data-role');
    maxDate.setFullYear(maxDate.getFullYear() + 2);
    $.datepicker.regional['es'] = {
      closeText: 'Cerrar',
      prevText: 'Anterior',
      nextText: 'Siguiente',
      currentText: 'Hoy',
      monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
      monthNamesShort: ['Ene','Feb','Mar','Abr', 'May','Jun','Jul','Ago','Sep', 'Oct','Nov','Dic'],
      dayNames: ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
      dayNamesShort: ['Dom','Lun','Mar','Mié','Juv','Vie','Sáb'],
      dayNamesMin: ['Do','Lu','Ma','Mi','Ju','Vi','Sá'],
      weekHeader: 'Sm',
      dateFormat: 'yy-mm-d',
      firstDay: 1,
      isRTL: false,
      showMonthAfterYear: false,
      yearSuffix: '',
      maxDate: maxDate
    };
    $.datepicker.setDefaults($.datepicker.regional['es']);


    function changeStatusByString (status) {
        status = parseInt(status);
        switch(status) {
            case 10:
                return "Estatus actualizado";
            case 11:
                return 'Asignación de gerencia';
            case 12:
                return 'Asignación de ejecutivo';
            case 13:
                return 'Gerencia desasignada';
            case 14:
                return 'Usuario desasignado';
            case 16:
                return 'Intento de contacto';
            case 21:
                return 'Cita/Compromiso agendado';
            case 22:
                return 'Cita/Compromiso reagendado';
            case 23:
                return 'Cita/Compromiso cancelado';
            case 24:
                return 'Cita/Compromiso concretado';
            case 31:
                return 'Servicio adicional requerido';
            case 32:
                return 'Servicio requerido';
            default :
                return 'Otras acciones';
        }    
    }

    var prepopulateData = function(ajaxConfig, element, values) {
        $.each(values, function(idx, elem) {
            var query = ajaxConfig.data({
                term : elem,
                page : 1,
            }, element);
            if(query.filter == 'user-id') {
                query.filter = 'emp_number';
            }
            $.get(ajaxConfig.url, query, function(data){
                results = ajaxConfig.processResults(data).results;
                var result = results[0];
                if(result != undefined) {
                    element.append("<option value='"+result.id+"' selected>"+result.text+"</option>");
                    element.trigger('change');    
                } else {
                    console.error("Cannot find results for", element, query);
                }
                
            })
        });
    }

    $('#status,#service,#management_id').select2({theme:"bootstrap"});
    
    //Esto solo funciona cuando se van a insertar caracteres en los filtros de la modal
    $('.select-2').each(function(){

        var action = laroute.action("Api\ClientsController@index");
        var $select = $(this);

        var name = $(this).attr('data-name');

        var ajaxConfig = {
            dataType: 'json',
            url: action,
            data : function(param, elem){
                if(elem == undefined) {
                    elem = $(this);
                }
                return {
                    filter : $(elem).attr('data-name'),
                    page: param.page,
                    values : param.term,
                }
            },            
            processResults: function (data) {
                var result = [];
                var datos = data.clients;
                for(var i=0; i<datos.length; i++) {

                    var client = datos[i];
                    
                    if(data.filter == 'cuenta'){
                        result.push({id : client.cuenta, text : client.cuenta });
                    }
                    if(data.filter == 'gerencia')
                        result.push({id : client.id, text : client.name });
                    if(data.filter == 'nss')
                        result.push({id : client.nss, text : client.nss });
                    if(data.filter == 'curp')
                        result.push({id : client.curp, text : client.curp });
                    if(data.filter == 'user-id')
                        result.push({id : client.id, text : client.employee_number });
                    if(data.filter == 'emp-number')
                        result.push({id : client.id, text : client.employee_number });
                    if(data.filter == 'municipio')
                        result.push({id : client.buc_munodel, text : client.buc_munodel });
                    if(data.filter == 'ciudad')
                        result.push({id : client.buc_ciudad, text : client.buc_ciudad });
                    if(data.filter == 'municipio')
                        result.push({id : client.municipio, text : client.municipio });
                    if(data.filter == 'empresa')
                        result.push({id : client.empresa, text : client.empresa });
                    
                    if(data.filter == 'puntos')
                        result.push({id : client.puntos, text : client.puntos });
                    
                }
                
                return {results:result};
            }
        }
        if(['kind'].indexOf(name) >= 0) {
            $(this).select2({theme : 'bootstrap'});
        } else {
            $(this).select2({
                minimumInputLength: ($(this).attr('data-name') == 'gerencia' || $(this).attr('data-name') == 'status' || $(this).attr('data-name') == 'service' ) ? 0 : 3,
                delay : 250,
                ajax: ajaxConfig,
                theme: "bootstrap",
                tokenSeparators : name == 'cuenta' || name == 'nss' || name == 'curp' ? [',', ' '] : undefined,
                placeholder: $(this).attr('placeholder'),
                language: "es",
                language : {
                    noResults :function(){
                        return "No se encontraron resultados."
                    }
                },
                
            });    

            var name = $(this).attr('name');
            var prevInput = $('#previousfilters input[name="'+ name +'"]');
            var values = [];
            prevInput.each(function(){
                values.push($(this).val());
            });
            prepopulateData(ajaxConfig, $(this), values);
        }
        
    });

    
    $('#filters-button').click(function(){
        // filtersButtonClick();
        $('#message').addClass('hidden');
        $('#filter-button').text('Filtrar');
        $('#excel').remove();
    });

    //esto llena los filters usados anteriormente    
    
    $('#filter-button').click(function(){
        $('html').prop('show-loader', false);
        $('#filters-modal form').submit();
    }); 

    $('#report-request-button').click(function(){
        
        // filtersButtonClick();
        $('#filters-modal form').append('<input type="hidden" name="excel" value="excel" id="excel">');
        $('#filters-modal #message').removeClass('hidden');
        
        $('#filter-button').text('Solicitar reporte');

        $('#filters-modal').modal();

    }); 

    // Validación/Reestricción de fechas en campo date 'Hasta'

    $('#from').datepicker({
        dateFormat:'dd/mm/yy',
        onSelect: function (date) {
            
            var to = $('#to').datepicker('getDate').getTime();
            if(to < date){
                $('#to').datepicker('setDate', date);
            }

            $('#to').datepicker('option', 'minDate', date);
            
            var date_array = date.split('/');
            var date_object = new Date(parseInt(date_array[2]) ,parseInt(date_array[1])-1,parseInt(date_array[0]));

            if(role == 'manager'){    
                var final_date = new Date (date_object.setMonth(date_object.getMonth() + 12));
                var final_date = final_date.getDate() + "/" + (final_date.getMonth() + 1) + "/" + final_date.getFullYear();
                $('#to').datepicker('option', 'maxDate', final_date);

            }

            if(role == 'executive'){

                var final_date = new Date (date_object.setMonth(date_object.getMonth() + 6));
                var final_date = final_date.getDate() + "/" + (final_date.getMonth() + 1) + "/" + final_date.getFullYear();
                $('#to').datepicker('option', 'maxDate', final_date);

            }
        },

    });


    $('#to').datepicker({
        dateFormat:'dd/mm/yy',
        onSelect(date){
            
            var date_array = date.split('/');
            var date_object = new Date(parseInt(date_array[2]) ,parseInt(date_array[1])-1,parseInt(date_array[0]));

            if(role == 'manager'){    
                var final_date = new Date (date_object.setMonth(date_object.getMonth() - 12));
                var final_date = final_date.getDate() + "/" + (final_date.getMonth() + 1) + "/" + final_date.getFullYear();
                console.log(final_date);
                $('#from').datepicker('option', 'minDate', final_date);
            }

            if(role == 'executive'){

                var final_date = new Date (date_object.setMonth(date_object.getMonth() - 6));
                var final_date = final_date.getDate() + "/" + (final_date.getMonth() + 1) + "/" + final_date.getFullYear();
                console.log(final_date);
                $('#from').datepicker('option', 'minDate', final_date);

            }            
        },
        
            
    });


    $('#from').datepicker({
        minDate: 
            role == 'executive' ? ( $("#to").datepicker('getDate').getMonth() - 6 ) : (role == 'manager' ? ($("#to").datepicker('getDate').getMonth() - 12) : null)          
    });

    $('#to').datepicker({
        maxDate: role == 'executive' ? ( $("#from").datepicker('getDate').getMonth() - 6 ) : (role == 'manager' ? ($("#from").datepicker('getDate').getMonth() - 12) : null)
    });


    /*Estilo para el tamaño del calendario*/
    $('#from').focus(function(){
        $('.ui-datepicker').css('width', $(this).parents().find('.input-group').width() + 'px');
        font_size = parseFloat($(this).parents().find('.input-group').css('font-size'));
        $('.ui-datepicker').css('font-size', font_size -0.5);
    });
    $('#to').focus(function(){
        $('.ui-datepicker').css('width', $(this).parents().find('.input-group').width() + 'px');
        font_size = parseFloat($(this).parents().find('.input-group').css('font-size'));
        $('.ui-datepicker').css('font-size', font_size -0.5);
    });
  
}); 
