<!-- Modal -->
<div id="filters-modal" class="modal fade" role="dialog">
  <div class="modal-dialog  {{Auth::user()->role == 'admin' ? 'modal-lg' : ''}} ">

    <!-- Modal content-->
    <div class="modal-content">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal">&times;</button>
            <h4 class="modal-title">Filtros</h4>
        </div>
        <div class="modal-body">
            <h3 class="hidden" id="message">
                <center style="color:red">El reporte se descargara con los siguientes filtros.</center>
            </h3>
            <br>
            {!!Form::open(['method' => 'GET', 'id' => 'form-with-filters'])!!}
                <div class="row">
                    <div class="col  {{Auth::user()->role == 'admin' ? 'col-md-4' : 'col-md-6'}}" >
                        <div class="form-group">
                            {!!Form::label('user_id','NÚMERO DE EMPLEADO',['class' => 'label-control'])!!}
                            {!!Form::select('user_id[]',[],null,['data-name' => 'user-id','class' => ' select-2','multiple' => 'multiple','style' => 'width:100%',"id" => 'user_id'])!!} 
                        </div>        
                    </div>
                    <div class="col {{Auth::user()->role == 'admin' ? 'col-md-4' : 'col-md-6'}}">
                        <!--<div class="form-group">
                            {!!Form::label('kind','ACCIÓN',['class' => 'label-control'])!!}
                            {!!Form::select('kind[]',[
                                10 => "Estatus actualizado",
                                11 => 'Asignación de gerencia',
                                12 => 'Asignación de ejecutivo',
                                13 => 'Gerencia desasignada',
                                14 => 'Usuario desasignado',
                                16 => 'Intento de contacto',
                                21 => 'Cita/Compromiso agendado',
                                22 => 'Cita/Compromiso reagendado',
                                23 => 'Cita/Compromiso cancelado',
                                24 => 'Cita/Compromiso concretado',
                                31 => 'Servicio adicional requerido',
                                32 => 'Servicio requerido',
                            ],null,['data-name' => 'kind','class' => ' select-2','multiple' => 'multiple','style' => 'width:100%',"id" => 'kind'])!!} 
                        </div>  -->

                        <div class="form-group">
                            {{Form::label('status','ESTATUS',['class' => 'label-control'])}}
                            {{Form::select('status[]',$status,request()->input('status'),['data-name' => 'status', 'multiple' => 'multiple','style' => 'width:100%','id' => 'status'])}}     
                        </div>
                    </div>
                    @if(Auth::user()->role == 'admin')
                        <div class="col col-md-4">
                            <div class="form-group">
                                {!!Form::label('management_id','GERENCIA',['class' => 'label-control'])!!}
                                {!!Form::select('management_id[]', App\Management::lists('name', 'id')->all() , request()->input('management_id'),['multiple' => 'multiple','style' => 'width:100%',"id" => 'management_id'])!!} 
                            </div>        
                        </div>
                    @endif
                </div>

                <div class="row form-group">
                    <div class="col col-xs-4">
                        {!!Form::label('from','Desde',['class' => 'label-control'])!!}
                        <div class="input-group">
                            {!!Form::input('text','from',request()->input('from', \Carbon\Carbon::today()->subMonths(6)->startOfMonth()->format('d/m/Y')),['class' => 'form-control date' ,'id' => 'from',"data-role" => auth()->user()->role])!!}
                            <span class="calendar-btn input-group-addon"><i class="fa fa-calendar"></i></span>
                        </div>                         
                    </div>
                    <div class="col col-xs-4">
                        {!!Form::label('to','Hasta',['class' => 'label-control'])!!}
                        <div class="input-group">
                            {!!Form::input('text','to',request()->input('to', \Carbon\Carbon::today()->endOfMonth()->format('d/m/Y')),['class' => 'form-control date' ,'id' => 'to',
                                "data-role" => auth()->user()->role])!!}
                            <span class="calendar-btn input-group-addon"><i class="fa fa-calendar"></i></span>
                        </div>
                    </div>    
                    <div class="col col-xs-4">
                        {!!Form::label('cuenta','Cuenta',['class' => 'label-control'])!!}
                        {{Form::select('cuenta[]',[],null,['data-name' => 'cuenta','class' => ' select-2','multiple' => 'multiple','style' => 'width:100%','id' => 'cuenta'])}} 

                    </div>
                    
                </div>

                

            {!! Form::close() !!}       
            <div id="previousfilters" class="hide">
                @foreach(['cuenta', 'user_id'] as $item) 
                    @foreach(request()->input($item, []) as $prevVal)
                        <input name="{{$item}}[]" value="{{$prevVal}}">
                    @endforeach
                @endforeach
            </div>
        </div>
        <div class="modal-footer">
            <button class="btn btn-primary" id="filter-button">Filtrar</button>
            <button type="button" class="btn btn-default" data-dismiss="modal">
                    Cancelar</button>
        </div>
    </div>
  </div>
</div>